ig.module(
	'plugins.dc.system'
)
.requires(
	'impact.system'
)
.defines(function(){

if(ig && !ig.setAnimation) {
	ig.setAnimation = function( callback, element ) {
		return window.setInterval( callback, 1000/60 );
	};
	ig.clearAnimation = function( id ) {
		window.clearInterval( id );
	};
}

ig.System.inject({
	init: function( canvasId, fps, width, height, scale ) {
		this.fps = fps;

		this.clock = new ig.Timer();
		this.canvas = AppMobi.canvas;
		this.context = this.canvas.getContext('2d');
		this.resize( width, height, scale );

		//added in impact 1.2.0
		if(ig && ig.System && ig.System.drawMode) {
			this.getDrawPos = ig.System.drawMode;
		}
		
		this.wasStopped = false;
	},

	resize: function( width, height, scale ) {
		if(AppMobi.isnative) {
			this.canvas.width = width;//this.context.width = this.width;
			this.canvas.height = height;//this.context.height = this.height;

			this.width = this.canvas.width;
			this.height = this.canvas.height;
			this.realWidth = this.width * this.scale;
			this.realHeight = this.height * this.scale;

			this.context.globalScale = scale;
		} else {
			this.parent(width, height, scale);
		}
	},	

	startRunLoop: function() {
		if(this.wasStopped) {
			ig.clearAnimation( this.animationId );
			this.running = false;
		}
		this.wasStopped = false;
		this.animationId = ig.setAnimation( this.run.bind(this), this.canvas );
		this.running = true;
	},

	stopRunLoop: function() {
		this.wasStopped = true;
	},

	run: function() {
		if(this.wasStopped) {
			ig.clearAnimation( this.animationId );
			this.running = false;
		} else {
			this.parent();
			this.context.present();
		}
	},
    
	getDrawPos: function(p) {
		return p;
	}
	
});


});
