/*global AppMobi */

var AccelerometerBridge = {};
AccelerometerBridge.options = {
    frequency: 100,
    adjustForRotation: true
};
AccelerometerBridge.callback = null;
AccelerometerBridge.watchId = null;

AccelerometerBridge.startWatch = function(callback) { "use strict";
    if (AccelerometerBridge.watchId) {
        return;
    }
    AccelerometerBridge.callback = callback;
    AccelerometerBridge.watchId = AppMobi.accelerometer.watchAcceleration(function(accel) {
        AppMobi.canvas.execute(AccelerometerBridge.callback + "(" + accel.x + ", " + accel.y + ", " + accel.z + ");");
    }, AccelerometerBridge.options);
};

AccelerometerBridge.stopWatch = function() { "use strict";
    if (AccelerometerBridge.watchId) {
        AppMobi.accelerometer.clearWatch(AccelerometerBridge.watchId);
        AccelerometerBridge.watchId = null;
    }
};
