/*global AppMobi */

var FacebookBridge = {};

/**
 * FacebookBridge.login()
 * FacebookBridge.login('CALLBACK')
 * FacebookBridge.login('CALLBACK', 'offline_access')
 * FacebookBridge.login('CALLBACK', ['offline_access', 'email', 'user_birthday'])
 */
FacebookBridge.login = function(callback, permissions) { "use strict";
    FacebookBridge.callback = callback;
    if (permissions === undefined) {
        AppMobi.facebook.login('');
    } else {
        if (!(permissions instanceof Array)) {
            permissions = [permissions];
        }
        AppMobi.facebook.login(permissions.join(','));
    }

};

FacebookBridge.loginResponse = function(e) { "use strict";
    if (FacebookBridge.callback) {
        AppMobi.canvas.execute(FacebookBridge.callback + "(" + e.success + ", '" + e.token + "');");
        FacebookBridge.post();
    }
};

FacebookBridge.logout = function(callback) { "use strict";
    FacebookBridge.callback = callback;
	AppMobi.facebook.logout();
};

FacebookBridge.logoutResponse = function(e) { "use strict";
    if (FacebookBridge.callback) {
        AppMobi.canvas.execute(FacebookBridge.callback + "(" + e.success + ");");
    }
};

/**
 * FacebookBridge.request()
 * FacebookBridge.request('CALLBACK')
 * FacebookBridge.request('CALLBACK', 'email')
 * FacebookBridge.request('CALLBACK', ['id', 'email', 'picture'])
 */
FacebookBridge.request = function(callback, fields) { "use strict";
    FacebookBridge.callback = callback;
    if (fields === undefined) {
        AppMobi.facebook.requestWithGraphAPI('me', 'GET', '');
    } else {
        if (!(fields instanceof Array)) {
            fields = [fields];
        }
        AppMobi.facebook.requestWithGraphAPI('me', 'GET', {fields: fields.join(',')});
    }
};

FacebookBridge.requestResponse = function(e) { "use strict";
    if (FacebookBridge.callback) {
        AppMobi.canvas.execute(FacebookBridge.callback + "(" + e.success + ", '" + JSON.stringify(e.data) + "');");
    }
};

FacebookBridge.invite = function(to, msg) { "use strict";
    //@todo
    var title = 'DuckyOp Invitation';
    AppMobi.facebook.showAppRequestDialog({"to": to, "message": msg, "title": title});
};

FacebookBridge.post = function(score, gameId, gameName) { "use strict";
    var description = "Hey I got " + score + " Op playing DuckyOp on mobile";
    if (gameId && gameName) {
        description += " in #ROOM" + gameId + "- " + gameName ;
    }
    description += "! Can you beat me?";
    var params = {
        "picture": "http://www.duckyop.com/fb/logo.jpg",
        "name": "DuckyOp",
        "caption": "New Score",
//        "properties": {
//            "property1":"blue"
//        },
//        "description": "Hey I got " + score + " Op playing DuckyOp on mobile! Can you beat me?",
        "description": description,
        "link": "https://www.facebook.com/DuckyOp"
    };
    AppMobi.facebook.showNewsFeedDialog(params);
};

FacebookBridge.dialogResponse = function() { "use strict";
    //@todo
};

FacebookBridge.init = function() { "use strict";
    document.addEventListener("appMobi.facebook.login", FacebookBridge.loginResponse, false);
    document.addEventListener("appMobi.facebook.request.response", FacebookBridge.requestResponse, false);
    document.addEventListener("appMobi.facebook.dialog.complete", FacebookBridge.dialogResponse, false);
    document.addEventListener("appMobi.facebook.logout", FacebookBridge.logoutResponse, false);
};
