/*global AppMobi */

var ImpactBridge = {};

ImpactBridge.init = function() { "use strict";
    var ua = {};
    ua.pixelRatio = window.devicePixelRatio || 1;
    ua.screen = {
        width: window.screen.availWidth * ua.pixelRatio,
        height: window.screen.availHeight * ua.pixelRatio
    };
    ua.viewport = {
        width: window.innerWidth,
        height: window.innerHeight
    };
    ua.viewportRatio = ua.screen.width / ua.screen.height;
    if (ua.viewportRatio < 1) {
        ua.viewportRatio = 1 / ua.viewportRatio;
    }
    ua.iPhone = /iPhone/i.test(navigator.userAgent);
    ua.iPhone4 = (ua.iPhone && ua.pixelRatio === 2);
    ua.iPhone5 = (ua.iPhone4 && ua.screen.height === 1136);
    ua.iPad = /iPad/i.test(navigator.userAgent);
    ua.android = /android/i.test(navigator.userAgent);
    ua.winPhone = /Windows Phone/i.test(navigator.userAgent);
    ua.iOS = ua.iPhone || ua.iPad;
    ua.mobile = ua.iOS || ua.android || ua.winPhone || /mobile/i.test(navigator.userAgent);
    ua.touchDevice = (('ontouchstart' in window) || (window.navigator.msMaxTouchPoints));
    if (!intel.xdk.isxdk) {
        if (ua.iPad) {
            ua.viewportRatio = 4 / 3;
        } else if (ua.iPhone5) {
            ua.viewportRatio = 71 / 40;
        } else if (ua.iPhone) {
            ua.viewportRatio = 3 / 2;
        }
    }
    ua.gameViewport = {};
    if (ua.viewportRatio < 1.5) {
        ua.gameViewport.width = 480;
        ua.gameViewport.height = Math.round(480 / ua.viewportRatio);
    } else {
        ua.gameViewport.width = 320 * ua.viewportRatio;
        ua.gameViewport.height = 320;
    }
    // only update pixelRatio & related info
    AppMobi.canvas.execute("ig.ua.screen.width = " + ua.pixelRatio + " * ig.ua.screen.width / ig.ua.pixelRatio;");
    AppMobi.canvas.execute("ig.ua.screen.height = " + ua.pixelRatio + " * ig.ua.screen.height / ig.ua.pixelRatio;");
    AppMobi.canvas.execute("ig.ua.pixelRatio = " + ua.pixelRatio + ";");
    AppMobi.canvas.execute("ig.ua.iPhone4 = (ig.ua.iPhone && ig.ua.pixelRatio === 2);");
    AppMobi.canvas.execute("ig.ua.android = " + ua.android + ";");
    AppMobi.canvas.execute("ig.ua.viewport.width = " + ua.gameViewport.width + ";");
    AppMobi.canvas.execute("ig.ua.viewport.height = " + ua.gameViewport.height + ";");
};
