//
//  inmobiplugin.js
//  INMOBI INTEL XDK PLUGIN
//
//  Copyright (c) 2013 InMobi. All rights reserved.
//

if (typeof(InMobiPluginInfo) != 'object')
InMobiPluginInfo = {};

//Defining the Plugin version
InMobiPlugin = { queue: { ready: true, commands: [], timer: null }, _constructors: [], version: "4.0.3", counter: 0 };


InMobiPlugin.Register = function() {
	if (AppMobi.device.platform == "Android")
		AppMobi.device.registerLibrary("com.inmobi.inmobiplugin.InMobiPluginModule");
	if (AppMobi.device.platform == "iOS")
		AppMobi.device.registerLibrary("InMobiPluginModule");
}

InMobiPlugin.Loaded = function() {
	while (InMobiPlugin._constructors.length > 0) {
		var constructor = InMobiPlugin._constructors.shift();
		try {
			constructor();
		} catch (e) {
			alert("Failed to run constructor: " + e.message);
		}
	}
    
	// all constructors run, now fire the ready event
	InMobiPlugin.available = true;
	var e = document.createEvent('Events');
	e.initEvent('inmobiplugin.ready', true, true);
	document.dispatchEvent(e);
}

// Handle Loading of appMobi Library
document.addEventListener("appMobi.device.ready", InMobiPlugin.Register, false);

/**
 * Add an initialization function to a queue that ensures our JavaScript
 * object constructors will be run only once our module has been loaded
 */
InMobiPlugin.addConstructor = function(constructor) {
	var state = document.readyState;
	if ((state == 'loaded' || state == 'complete') && InMobiPluginInfo.ready != "undefined") {
		constructor();
	} else {
		InMobiPlugin._constructors.push(constructor);
	}
};

//Begin Javascript definition of InMobiPlugin.Ads which bridges to InMobiAds
InMobiPlugin.Ads = function() {
	this.id = InMobiPlugin.counter++;
	InMobiPlugin.bannermap[this.id] = this;
}
InMobiPlugin.Analytics = function() {
    
}
InMobiPlugin.bannermap = {};

//revised APIs

InMobiPlugin.Analytics.prototype.startSessionManually = function(properties) {
	if (AppMobi.device.platform == "Android") {
		properties = properties || {};
		InMobiPluginAds.startSessionManually(JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.startSessionManually");
}


InMobiPlugin.Analytics.prototype.endSessionManually = function(properties) {
	if (AppMobi.device.platform == "Android") {
		properties = properties || {};
		InMobiPluginAds.endSessionManually(JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.endSessionManually");
}

InMobiPlugin.Analytics.prototype.beginSection = function(sectionName, properties) {
	if ((typeof sectionName === "undefined") || (sectionName === "") || (typeof sectionName !== "string")) {
		sectionName = null;
	}
    properties = properties || {};
	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.beginSection(sectionName, JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.beginSection", sectionName, JSON.stringify(properties));
}

InMobiPlugin.Analytics.prototype.endSection = function(sectionName, properties) {
	if ((typeof sectionName === "undefined") || (sectionName === "") || (typeof sectionName !== "string")) {
		sectionName = null;
	}
    properties = properties || {};
	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.endSection(sectionName, JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.endSection", sectionName, JSON.stringify(properties));
}

InMobiPlugin.Analytics.prototype.tagEvent = function(eventName, properties) {
	if ((typeof eventName === "undefined") || (eventName === "") || (typeof eventName !== "string")) {
		eventName = null;
	}
    properties = properties || {};

	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.tagEvent(eventName, JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.tagEvent", eventName, JSON.stringify(properties));
}

InMobiPlugin.Ads.prototype.initialize = function(properties) {
	if (typeof properties == "undefined") {
		return;
	}
    properties = properties || {};
	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.initialize(JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS") {
		AppMobi.exec("InMobiAds.initialize", JSON.stringify(properties));
    }
}

InMobiPlugin.Ads.prototype.initBannerAd = function(properties) {
    properties = properties || {};

	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.initBannerAd(this.id, JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.initBannerAd", this.id, JSON.stringify(properties));
}

InMobiPlugin.Ads.prototype.loadBannerAd = function() {
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.loadBannerAd(this.id);
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.loadBannerAd", this.id);
}

InMobiPlugin.Ads.prototype.removeBannerAd = function() {
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.removeBannerAd(this.id);
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.removeBannerAd", this.id);
}

InMobiPlugin.Ads.prototype.initInterstitialAd = function(properties) {
    properties = properties || {};

	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.initInterstitialAd(JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.initInterstitialAd", JSON.stringify(properties));
}

InMobiPlugin.Ads.prototype.loadInterstitialAd = function() {
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.loadInterstitialAd();
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.loadInterstitialAd");
}

InMobiPlugin.Ads.prototype.showInterstitialAd = function() {
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.showInterstitialAd();
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.showInterstitialAd");
}

InMobiPlugin.Ads.prototype.setAdRequestProperties = function(properties) {
    properties = properties || {};

	if (AppMobi.device.platform == "Android") {
		InMobiPluginAds.setAdRequestProperties(JSON.stringify(properties));
	}
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.setAdRequestProperties", JSON.stringify(properties));
}

InMobiPlugin.Ads.prototype.setLogLevel = function(logLevel) {
	if ((typeof logLevel == "undefined") || (typeof logLevel != "number")) {
		logLevel = 0;
	}
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.setLogLevel(logLevel);
	if (AppMobi.device.platform == "iOS")
		AppMobi.exec("InMobiAds.setLogLevel", logLevel);
}

InMobiPlugin.Ads.prototype.getAppmobiPluginVersion = function() {
	return (InMobiPlugin.version);
}

InMobiPlugin.Ads.prototype.bannerDisableHardwareAcceleration = function() {
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.bannerDisableHardwareAcceleration(this.id);
}

InMobiPlugin.Ads.prototype.interstitialDisableHardwareAcceleration = function() {
	if (AppMobi.device.platform == "Android")
		InMobiPluginAds.interstitialDisableHardwareAcceleration();
}

// Begin Javascript definition of InMobiPlugin.Setup which bridges to InMobiPluginSetup
InMobiPlugin.Setup = function() {
	this.ready = null;
	try {
		this.ready = InMobiPluginInfo.ready;
	} catch (e) {}
}

InMobiPlugin.addConstructor(function() {
                            if (typeof InMobiPlugin.setup == "undefined") InMobiPlugin.setup = new InMobiPlugin.Setup();
                            });

InMobiPlugin.addConstructor(function() {
                            if (typeof InMobiPlugin.analytics == "undefined") InMobiPlugin.analytics = new InMobiPlugin.Analytics();
                            });
InMobiPlugin.addConstructor(function() {
                            if (typeof InMobiPlugin.ads == "undefined") InMobiPlugin.ads = new InMobiPlugin.Ads();
                            });
