/*global AppMobi */

var InputBridge = {};
InputBridge.callback = null;
InputBridge.CANCEL = '___CANCEL___';

InputBridge.showForm = function(allowCancel) { "use strict";
    var e = document.getElementById('new-user');
    e.style.display = '';
    e = document.getElementById('btn-ok');
    e.addEventListener('click', InputBridge.hideForm, false);
    e = document.getElementById('btn-cancel');
    e.style.display = allowCancel ? '' : 'none';
    e.addEventListener('click', InputBridge.closeForm, false);
    e = document.getElementById('user-name');
    e.addEventListener('keyup', InputBridge.formInputKeyUp, false);
    e.value = '';
};

InputBridge.hideForm = function() { "use strict";
    var e = document.getElementById('new-user');
    e.style.display = 'none';
    e = document.getElementById('btn-ok');
    e.removeEventListener('click', InputBridge.hideForm, false);
    e = document.getElementById('btn-cancel');
    e.removeEventListener('click', InputBridge.closeForm, false);
    e = document.getElementById('user-name');
    e.removeEventListener('keyup', InputBridge.formInputKeyUp, false);
    if (InputBridge.callback) {
        AppMobi.canvas.execute(InputBridge.callback + '("' + e.value.toString().toLowerCase() + '");');
    }
};

InputBridge.closeForm = function() { "use strict";
    var e = document.getElementById('new-user');
    e.style.display = 'none';
    e = document.getElementById('btn-ok');
    e.removeEventListener('click', InputBridge.hideForm, false);
    e = document.getElementById('btn-cancel');
    e.removeEventListener('click', InputBridge.closeForm, false);
    e = document.getElementById('user-name');
    e.removeEventListener('keyup', InputBridge.formInputKeyUp, false);
    if (InputBridge.callback) {
        AppMobi.canvas.execute(InputBridge.callback + '("' + InputBridge.CANCEL + '");');
    }
};

InputBridge.formInputKeyUp = function(event) { "use strict";
    event.preventDefault();
    if (event.keyCode === 13) {
        InputBridge.hideForm();
        event.stopPropagation();
    }
};

InputBridge.showInput = function() { "use strict";
    var left   = 134;
    var top    = 167 - 75;
    var width  = 190;
    var height = 12;
    var font   = 0.8;
//    var screenWidth = screen.availWidth;
    var screenHeight = screen.availHeight;
    var _pixelRatio = window.devicePixelRatio || 1;
    var _iPhone = /iPhone/i.test(navigator.userAgent);
    var _iPhone4 = (_iPhone && _pixelRatio === 2 && screenHeight === 480);
    var _iPhone5 = (_iPhone && _pixelRatio === 2 && (screenHeight === 548 || screenHeight === 568));
    if (_iPhone4) {
        left -= 8;
        top -= 4;
        width -= 16;
    } else if (_iPhone5) {
        left -= 24;
        top -= 16;
        width -= 36;
    }
    var e = document.getElementById('user-name');
    e.value = '';
    e.style.top = top + 'px';
    e.style.left = left + 'px';
    e.style.height = height + 'px';
    e.style.width = width + 'px';
    e.style.fontSize = font + 'em';
    e.style.display = '';
    e.addEventListener('keyup', InputBridge.inputKeyUp, false);
    e.focus();
};

InputBridge.hideInput = function() { "use strict";
    var e = document.getElementById('user-name');
    e.removeEventListener('keyup', InputBridge.inputKeyUp, false);
    e.style.display = 'none';
    if (InputBridge.callback) {
        AppMobi.canvas.execute(InputBridge.callback + '("' + e.value.toString().toLowerCase() + '");');
    }
};

InputBridge.closeInput = function() { "use strict";
    var e = document.getElementById('user-name');
    e.removeEventListener('keyup', InputBridge.inputKeyUp, false);
    e.style.display = 'none';
    if (InputBridge.callback) {
        AppMobi.canvas.execute(InputBridge.callback + '("' + InputBridge.CANCEL + '");');
    }
};

InputBridge.inputKeyUp = function(event) { "use strict";
    event.preventDefault();
    if (event.keyCode === 13) {
        InputBridge.hideInput();
        event.stopPropagation();
    }
};
