/*global AppMobi, OneTouch */

var PaymentBridge = {};
PaymentBridge.successCallback = null;
PaymentBridge.failureCallback = null;

PaymentBridge.oneTouchPaymentSucceeded = function(product) { "use strict";
    if (PaymentBridge.successCallback) {
        AppMobi.canvas.execute(PaymentBridge.successCallback + "('" + product + "');");
    }
};

PaymentBridge.oneTouchPaymentFailed = function(event) { "use strict";
    if (PaymentBridge.failureCallback) {
        AppMobi.canvas.execute(PaymentBridge.failureCallback + "('" + event.product + "');");
    }
};

PaymentBridge.oneTouchPurchase = function(productId, successCallback, failureCallback) { "use strict";
    PaymentBridge.successCallback = successCallback;
    PaymentBridge.failureCallback = failureCallback;
    /*#IF(NATIVE_BUILD)*/
    OneTouch.buy(productId, 1, PaymentBridge.oneTouchPaymentSucceeded, PaymentBridge.oneTouchPaymentFailed);
    /*#ELSE*
    if (true) {
        setTimeout(PaymentBridge.oneTouchPaymentSucceeded.bind(null, productId), 2000);
    } else {
        setTimeout(PaymentBridge.oneTouchPaymentFailed.bind(null, {product: productId}), 2000);
    }
    /*#ENDIF*/
};
