// -----------------------------------------------------------------------------
// AppMobi Object Replacement for standalone ImpactJS games
// -----------------------------------------------------------------------------
/**
 * AppMobi namespace
 * must be included before the game
 */
var AppMobi = {};

AppMobi.webview = {};
AppMobi.webview.execute = eval.bind();

AppMobi.canvas = {};
AppMobi.canvas.execute = eval.bind();
AppMobi.canvas.load = function() {};

AppMobi.context = {};
AppMobi.context.include = function() {};
AppMobi.context.playSound = function() {};

AppMobi.device = {};
AppMobi.device.setRotateOrientation = function() {};
AppMobi.device.managePower = function() {};
AppMobi.device.setAutoRotate = function() {};
AppMobi.device.hideSplashScreen = function() {};
AppMobi.device.hideStatusBar = function() {};
AppMobi.device.launchExternal = function() {};
AppMobi.device.platform = "web";

AppMobi.player = {};
AppMobi.player.playSound = function() {};

AppMobi.display = {};
AppMobi.display.useViewport = function() {};

AppMobi.orientation = "";

AppMobi.isweb = true;
AppMobi.isnative = false;

//@todo: this emulation is not working, try https://github.com/brian-c/phantom-limb
AppMobi.emulateTouchEvents = function() { "use strict";
    if (!document.ontouchstart || !document.ontouchmove || !document.ontouchend) {
        return;
    }
    AppMobi.redirectMouseToTouch = function (type, originalEvent) {
        // stop propagation, and remove default behavior for everything but INPUT, TEXTAREA, SELECT fields
        var tagName = originalEvent.target.tagName.toUpperCase();
        if (tagName !== "SELECT" && tagName !== "TEXTAREA" && tagName!== "INPUT") {
            originalEvent.stopPropagation();
        }
        var touchEvent = document.createEvent("Event");
        touchEvent.initEvent(type, true, true);
        touchEvent.touches = [];
        touchEvent.touches[0] = {};
        touchEvent.touches[0].pageX = originalEvent.clientX;
        touchEvent.touches[0].pageY = originalEvent.clientY;
        touchEvent.touches[0].target = originalEvent.target;
        // compatibility
        touchEvent.touches[0].clientX = originalEvent.clientX;
        touchEvent.touches[0].clientY = originalEvent.clientY;
        touchEvent.changedTouches = touchEvent.touches;
        touchEvent.targetTouches = touchEvent.touches;
        touchEvent.target = originalEvent.target;
        originalEvent.target.dispatchEvent(touchEvent);
        return touchEvent;
    };
    document.mouseMoving = false;
    document.onmousedown = function(event) {
        try {
            document.mouseMoving = true;
            var touchEvent = AppMobi.redirectMouseToTouch("touchstart", event);
            document.ontouchstart(touchEvent);
        } catch(e) {
        }
    };
    document.onmouseup = function(event) {
        try {
            document.mouseMoving = false;
            var touchEvent = AppMobi.redirectMouseToTouch("touchend", event);
            document.ontouchend(touchEvent);
        } catch(e) {
        }
    };
    document.onmousemove = function(event) {
        try {
            if (!document.mouseMoving) {
                return;
            }
            var touchEvent = AppMobi.redirectMouseToTouch("touchmove", event);
            document.ontouchmove(touchEvent);
        } catch(e) {
        }
    };
};
//AppMobi.emulateTouchEvents();

AppMobi.ready = function() { "use strict";
    AppMobi.available = true;
    var readyEvent = document.createEvent('Events');
    readyEvent.initEvent("appMobi.device.ready", true, true);
    document.dispatchEvent(readyEvent);
};
//AppMobi.ready();
