try
{

if(typeof(AppMobiCloudInit) != 'object')
    AppMobiCloudInit = {};

/**
 * This represents the AppMobiCloud API itself, and provides a global namespace for accessing
 * information about the state of AppMobiCloud.
 * @class
 */
AppMobiCloud = {
    _constructors: [],
	jsVersion: '4.0.0'
};

/**
 * Boolean flag indicating if the AppMobiCloud API is available and initialized.
 */
AppMobiCloud.isnative = true;
AppMobiCloud.updateAvailable = false;
AppMobiCloud.updateMessage = "";
AppMobiCloud.app = "";
AppMobiCloud.release = "";
AppMobiCloud.package = "";
    
AppMobiCloud.notifications = [];

function AppMobiCloudLoaded()
{
    while (AppMobiCloud._constructors.length > 0) {
        var constructor = AppMobiCloud._constructors.shift();
        try {
            constructor();
        } catch(e) {
                //alert("Failed to run constructor: " + e.message);
        }
    }
    
	setTimeout('AppMobiCloud.messager.messagePump();', 150);	

    // all constructors run, now fire the deviceready event
    AppMobiCloudInit.uuid = "0";
    AppMobiCloud.available = true;
    var e = document.createEvent('Events');
    e.initEvent('appMobiCloud.device.ready',true,true);
    document.dispatchEvent(e);
}

/**
 * Add an initialization function to a queue that ensures it will run and initialize
 * application constructors only once AppMobiCloud has been initialized.
 * @param {Function} func The function callback you want run once AppMobiCloud is initialized
 */
AppMobiCloud.addConstructor = function(func) {
    var state = document.readyState;
    if (( state == 'loaded' || state == 'complete' ) && AppMobiCloudInit.uuid != null)
        func();
    else
        AppMobiCloud._constructors.push(func);
};

AppMobiCloud.Advertising = function() {
};

AppMobiCloud.Advertising.prototype.runPromotion = function(appname, storeurl, promotion, protocol, package, query) {
    if( typeof( appname ) != "string" || appname.length == 0 ||
        typeof( storeurl ) != "string" || storeurl.length == 0 ||
        typeof( promotion ) != "string" || promotion.length == 0 ||
        typeof( protocol ) != "string" || protocol.length == 0 ||
        typeof( package ) != "string" || package.length == 0 )
		throw(new Error("Error: AppMobiCloud.advertising.runPromotion, appname, storeurl, promotion, protocol and package are required."));
	
	if( query == undefined || query.length == 0 ) query = "";
    
	AppMobiCloudAdvertising.runPromotion(appname, storeurl, promotion, protocol, package, query);
};

AppMobiCloud.addConstructor(function() {
    if (typeof AppMobiCloud.advertising == "undefined") AppMobiCloud.advertising = new AppMobiCloud.Advertising();
});

/**
 * This class provides access to the AppMobiCloud in-app purchasing system
 * @constructor
 */
AppMobiCloud.Purchasing = function() {
};

AppMobiCloud.Purchasing.prototype.purchaseProduct = function(productId, quantity, user) {
	var quan = parseInt(quantity);
	if( typeof(quan) == "undefined" ) {
		q = 1;
	}
	AppMobiCloudPurchasing.purchaseProduct(productId, quan, user);
};
    
AppMobiCloud.Purchasing.prototype.restorePurchases = function(user) {
    AppMobiCloudPurchasing.restorePurchases(user);
};

AppMobiCloud.addConstructor(function() {
	if (typeof AppMobiCloud.purchasing == "undefined") AppMobiCloud.purchasing = new AppMobiCloud.Purchasing();
});

/**
 * This class provides access to notifications on the device.
 */
AppMobiCloud.Notification = function() {
	eval(AppMobiCloudPush.getNotificationsString());
}

/**
 * This class specifies the attributes for push users.
 * @constructor
 */
AppMobiCloud.Notification.PushUserAttributes = function() {
	this.s1 = null;
	this.s2 = null;
	this.s3 = null;
	this.s4 = null;
	this.s5 = null;
	this.s6 = null;
	this.n1 = null;
	this.n2 = null;
	this.n3 = null;
	this.n4 = null;
};

AppMobiCloud.Notification.prototype.getNotificationList = function() {
	var notify = [];
	for(var note in AppMobiCloud.notifications) {
		notify.push(AppMobiCloud.notifications[note].id);
	}
	return notify;
};

AppMobiCloud.Notification.prototype.getNotificationData = function(id) {
	var local = null;
	for(var note in AppMobiCloud.notifications) {
		if(id==AppMobiCloud.notifications[note].id) {
			local = {};
			local.id = AppMobiCloud.notifications[note].id;
			local.msg = AppMobiCloud.notifications[note].msg;
			local.data = AppMobiCloud.notifications[note].data;
			local.userkey = AppMobiCloud.notifications[note].userkey;
			local.richurl = AppMobiCloud.notifications[note].richurl;
			local.richhtml = AppMobiCloud.notifications[note].richhtml;
			local.isRich = AppMobiCloud.notifications[note].isRich;
			break;
		}
	}
	return local;
};

AppMobiCloud.Notification.prototype.checkPushUser = function(userID, password) {
	if( userID   == undefined || userID   == "" ||
		 password == undefined || password == "" )
	{
		throw(new Error("Error: AppMobiCloud.notification.checkPushUser, No user or password specified."));
	}
	
	AppMobiCloudPush.checkPushUser(userID, password);
};

AppMobiCloud.Notification.prototype.addPushUser = function(userID, password, email) {
	if( userID   == undefined || userID   == "" || userID.indexOf(' ')!=-1 || userID.indexOf('.')!=-1 || 
		password == undefined || password == "" || password.indexOf(' ')!=-1 || password.indexOf('.')!=-1 ||
		email    == undefined || email    == "" )
	{
		throw(new Error("Error: AppMobiCloud.notification.addPushUser: User, email and password are required. The space (' ') and dot ('.') characters are not allowed in user and password."));
	}

	AppMobiCloudPush.addPushUser(userID, password, email);
};

AppMobiCloud.Notification.prototype.editPushUser = function(newEmail, newPassword, newUser) {
	if( ( newEmail == undefined || newEmail == "" ) &&
        ( newPassword == undefined || newPassword == "" || newPassword.indexOf(' ')!=-1 || newPassword.indexOf('.')!=-1 ) && 
        ( newUser == undefined || newUser == "" || newUser.indexOf(' ')!=-1 || newUser.indexOf('.')!=-1 ) )
	{
		throw(new Error("Error: AppMobiCloud.notification.editPushUser, No new value (email or password or user) specified. The space (' ') and dot ('.') characters are not allowed in user or password."));
	}

	AppMobiCloudPush.editPushUser(newEmail, newPassword, newUser);
};

AppMobiCloud.Notification.prototype.deletePushUser = function() {
	AppMobiCloudPush.deletePushUser();
};

AppMobiCloud.Notification.prototype.sendPushUserPass = function() {
	AppMobiCloudPush.sendPushUserPass();
};

AppMobiCloud.Notification.prototype.setPushUserAttributes = function(attributes) {
	if( attributes == undefined )
	{
		throw(new Error("Error: AppMobiCloud.notification.setPushUserAttributes: attributes is required."));
	}

	if( attributes.hasOwnProperty("s1") == false || attributes.hasOwnProperty("s2") == false || attributes.hasOwnProperty("s3") == false || attributes.hasOwnProperty("s4") == false 
	 || attributes.hasOwnProperty("s5") == false || attributes.hasOwnProperty("s6") == false || attributes.hasOwnProperty("n1") == false
	 || attributes.hasOwnProperty("n2") == false || attributes.hasOwnProperty("n3") == false || attributes.hasOwnProperty("n4") == false )
	{
		throw(new Error("Error: AppMobiCloud.notification.setPushUserAttributes: invalid attributes parameter specified. Initialize using 'new AppMobiCloud.Notification.PushUserAttributes'."));
	}

	if( (Number(attributes.n1) == NaN) || (Number(attributes.n2) == NaN) || 
			(Number(attributes.n3) == NaN) || (Number(attributes.n4) == NaN) )
	{
		throw(new Error("Error: AppMobiCloud.notification.setPushUserAttributes: attributes n1,n2,n3,n4 must be numbers."));
	}

	var parsedAttributes = "";
	for(var prop in attributes) {
		if( (prop=="s1"||prop=="s2"||prop=="s3"||prop=="s4"||prop=="s5"||prop=="s6"||prop=="n1"||prop=="n2"||prop=="n3"||prop=="n4") && attributes[prop] != null ) {
			parsedAttributes += "[";
			parsedAttributes += prop;
			parsedAttributes += "=";
			parsedAttributes += escape(attributes[prop]);
			parsedAttributes += "]";
		}
	}

	AppMobiCloudPush.setPushUserAttributes(parsedAttributes);
};

AppMobiCloud.Notification.prototype.findPushUser = function(userID, email) {
	AppMobiCloudPush.findPushUser(userID, email);
};

AppMobiCloud.Notification.prototype.refreshPushNotifications = function() {
	AppMobiCloudPush.refreshPushNotifications();
};

AppMobiCloud.Notification.prototype.refreshUserPushNotifications = function(user, pass, device, newerthan) {
	AppMobiCloudPush.refreshUserPushNotifications(user, pass, device, newerthan);
};

AppMobiCloud.Notification.prototype.readPushNotifications = function(notificationIDs) {
	if( notificationIDs == undefined || notificationIDs == "")
	{
		throw(new Error("Error: AppMobiCloud.notification.readPushNotifications, No notificationIDs specified."));
	}
	
	if( typeof( notificationIDs ) == "number" ) notificationIDs = "" + notificationIDs;

	AppMobiCloudPush.readPushNotifications(notificationIDs);
};

AppMobiCloud.Notification.prototype.deletePushNotifications = function(notificationIDs) {
	if( notificationIDs == undefined || notificationIDs == "")
	{
		throw(new Error("Error: AppMobiCloud.notification.deletePushNotifications, No notificationIDs specified."));
	}
	
	if( typeof( notificationIDs ) == "number" ) notificationIDs = "" + notificationIDs;

	AppMobiCloudPush.readPushNotifications(notificationIDs);
};

AppMobiCloud.Notification.prototype.sendPushNotification = function(userID, message, data) {
	if( userID  == undefined || userID  == "" ||
		message == undefined || message == "" )
	{
		throw(new Error("Error: AppMobiCloud.notification.sendPushNotification, No user or message specified."));
	}
	
    if( typeof( data ) != "string" ) data = "";	
	if( message.length > 1024 ) throw(new Error("Error: AppMobiCloud.notification.sendPushNotification, message cannot exceed 1024 characters in length."));
	if( data.length > 1024 ) throw(new Error("Error: AppMobiCloud.notification.sendPushNotification, data cannot exceed 1024 characters in length."));

	AppMobiCloudPush.sendPushNotification(userID, message, data);
};

AppMobiCloud.Notification.prototype.broadcastPushNotification = function(message, data, attributes, skip) {
	if( message == undefined || message == "" )
	{
		throw(new Error("Error: AppMobiCloud.notification.broadcastPushNotification, No message specified."));
	}
    
    if( typeof( data ) != "string" ) data = "";	
	if( message.length > 1024 ) throw(new Error("Error: AppMobiCloud.notification.broadcastPushNotification, message cannot exceed 1024 characters in length."));
	if( data.length > 1024 ) throw(new Error("Error: AppMobiCloud.notification.broadcastPushNotification, data cannot exceed 1024 characters in length."));
    
	AppMobiCloudPush.broadcastPushNotification( message, data, attributes, skip);
};

AppMobiCloud.Notification.prototype.showRichPushViewer = function(notificationID, closePortX, closePortY, closeLandX, closeLandY, closeWidth, closeHeight) {
	if( notificationID == undefined || notificationID  == "")
	{
		throw(new Error("Error: AppMobiCloud.notification.showRichPushViewer, No notification ID specified."));
	}
	
	var notification = AppMobiCloud.notification.getNotificationData( notificationID );
	if( notification == null || ( notification.richurl == "" && notification.richhtml == "" ) )
	{
		throw(new Error("Error: AppMobiCloud.notification.showRichPushViewer, This notification ID is not a rich message."));
	}
	
	AppMobiCloudPush.showRichPushViewer(notificationID, closePortX, closePortY, closeLandX, closeLandY, closeWidth, closeHeight);
};

AppMobiCloud.Notification.prototype.closeRichPushViewer = function() {
	AppMobiCloudPush.closeRichPushViewer();
};

AppMobiCloud.addConstructor(function() {
    if (typeof AppMobiCloud.notification == "undefined") AppMobiCloud.notification = new AppMobiCloud.Notification();
});

/**
 * This class provides access to the appMobiCloud message pump (to avoid keyboard issues)
 * @constructor
 */
AppMobiCloud.Messager = function() {
};

AppMobiCloud.Messager.prototype.messagePump = function() {
	if (typeof AppMobiCloudMessager != 'undefined') {
		var script = AppMobiCloudMessager.messagePump();
		if( script ) {
			try { eval(script); } catch(e) { console.log(e); };
		}
		setTimeout('AppMobiCloud.messager.messagePump();', 15);
	}
};

AppMobiCloud.addConstructor(function() {
    if (typeof AppMobiCloud.message == "undefined") AppMobiCloud.messager = new AppMobiCloud.Messager();
});

function loadAppMobiCloud()
{
    AppMobiDevice.registerLibrary("com.appMobiCloud.AppMobiCloudModule");
}

if( typeof(AppMobi) != "object" )
{
    alert("This appMobiCloud plugin requires appMobi.js to be included first");
}
else
{
    loadAppMobiCloud();
}
    
} catch(e) {
	console.log("error in appmobicloud.js : "+e.message);
}