DirectBox2d = new Box2D();
/*
AppMobi = function() {
	
	return {
		
		box2d: {

		},
		isnative: true//internal only
	}
}();
*/
b2 = AppMobi.box2d;
b2.SCALE = 0.1;  // for Impact games 
b2.Vec2 = b2Vec2;
b2Body = {
    b2_staticBody: 0,
    b2_kinematicBody: 1,
    b2_dynamicBody: 2
}

b2.AABB = function() {
				// bounding box is not needed to create the world in this version of box2d
				// implement if needed
			};
b2.Body = function(_bdef, _world, _id) {
				if(typeof _id=="undefined") {  
					this.id=DirectBox2d.BodyCreate(this, _bdef.id, _world.id);
					this._position=new b2.Vec2(0, 0);
				} else {
					this.id=_id;
					this._position=new b2.Vec2(0, 0);
					//console.log("Body id= "+_id);
				}
			}; 
b2.BodyDef = function() {
				this.id=DirectBox2d.BodyDefCreate(this);
				this._position=new b2.Vec2(0, 0);
				// if any property not changed can set default value here
				//this.type= ...
			};
b2.Contact = function(_id) {
				this.id=_id;
			};
b2.ContactListener = function() {
				this.id=DirectBox2d.ContactListenerCreate(this);
			};
b2.Fixture = function(_id) {
				if(typeof _id=="undefined") {  
					this.id=DirectBox2d.FixtureCreate(this);
				} else {
					this.id=_id;
				}
			};
b2.FixtureDef = function() {
				this.id=DirectBox2d.FixtureDefCreate(this);
			};
b2.CircleShape = function(_id) {
				if(typeof _id=="undefined") {  
					this.id=DirectBox2d.CircleShapeCreate(this);
				} else {
					//this.id=_id;
					this.id=DirectBox2d.CircleShapeCreate(this, _id);
				}
			};
b2.PolygonShape = function() {
				if(typeof _id=="undefined") {  
					this.id=DirectBox2d.PolygonShapeCreate(this);
				} else {
					this.id=DirectBox2d.PolygonShapeCreate(this, _id);
				}
			};
b2.Rot = function(angle) {
				if(typeof angle=="undefined") {
					this.s=0;
					this.c=1;
				} else {  
					this.s=Math.sin(angle);
					this.c=Math.cos(angle);
				}
			};
b2.Transform = function(position, rotation) {
				if(typeof position=="undefined") {
					this.p=new b2.Vec2(0, 0);
				} else {  
					this.p=position;
				}
				if(typeof rotation=="undefined") {
					this.q=new b2.Rot(0);
				} else {  
					this.q=rotation;
				}
			};
b2.World = function(g, s) {
				//:TODO - check for valid type of g
				//:TODO - implement default constructor for new World();
				this.gravity=g;
				this.doSleep=s;
				var ds=(s)?1:0;
				this.id=DirectBox2d.WorldCreate(this, g, ds);
			};

b2.DebugDraw = function () {
      b2.DebugDraw.b2DebugDraw.apply(this, arguments);
      ///if (this.constructor === b2.DebugDraw) this.b2.DebugDraw.apply(this, arguments);
   };


// The temp objects are used to avoid creating new objects each time we get a const property of an
// object.  These temp objects are reused so cannot be used to set something.
// This way the garbage collection load and corresponding memory management on native side is reduced.
//:TODO - review the following cases and modify implementation in objects that make sense to 
// remove the need for temp objects (similar to position in Body and BodyDef) 
//var _tempBodyPosition = new b2.Vec2(0, 0);
var _tempCirclePosition = new b2.Vec2(0, 0);
var _tempPolygonPosition = new b2.Vec2(0, 0);
var _tempFixtureDefCircleShape = new b2.CircleShape();
var _tempFixtureDefPolygonShape = new b2.PolygonShape();
var _tempFixtureCircleShape = new b2.CircleShape();
var _tempFixturePolygonShape = new b2.PolygonShape();


// Body
b2.Body.prototype = {
	get userData() {
		return JSON.parse(DirectBox2d.BodyGetUserData(this.id));
	}, 
	set userData(val) {
		DirectBox2d.BodySetUserData(this.id, JSON.stringify(val));
	}
}
b2.Body.prototype.CreateFixture = function(fixtureDef) {
	var fid = DirectBox2d.BodyCreateFixture(this.id, fixtureDef.id);
	var fix=new b2.Fixture(fid);
	return fix;
}
b2.Body.prototype.CreateFixture2 = function(shape, density) {
	if(typeof density=="undefined") {
		density=0;
	}
	var fid = DirectBox2d.BodyCreateFixture2(this.id, shape.id, density);
	var fix=new b2.Fixture(fid);
	return fix;
}
b2.Body.prototype.ApplyForce = function(force, point) {
	DirectBox2d.BodyApplyForce(this.id, force, point);
}
b2.Body.prototype.SetTransform = function(position, angle) {
	DirectBox2d.BodySetTransform(this.id, position, angle);
}
b2.Body.prototype.ApplyLinearImpulse = function(force, point) {
	DirectBox2d.BodyApplyLinearImpulse(this.id, force, point);
}
b2.Body.prototype.GetPosition = function() {
	DirectBox2d.BodyGetPosition(this.id, this._position);
	this._position.Vec2Update();
	return this._position;
}
b2.Body.prototype.GetRoundedAngle = function(x) {
	var ra = DirectBox2d.BodyGetRoundedAngle(this.id, x);
	return ra;
}
b2.Body.prototype.GetType = function() {
	var type = DirectBox2d.BodyGetType(this.id);
	return type;
}
b2.Body.prototype.GetLinearVelocity = function() {
	var v = DirectBox2d.BodyGetLinearVelocity(this.id);
	return v;
}
b2.Body.prototype.GetNext = function() {
	var id = DirectBox2d.BodyGetNext(this.id);
	if(id) {
		var b=new b2.Body(0, 0, id);
		return b;
	} else {
		return undefined;
	}
}
b2.Body.prototype.GetTransform = function() {
	var xf = DirectBox2d.BodyGetTransform(this.id);
	var xform =JSON.parse(xf);
	return xform;
}
b2.Body.prototype.GetFixtureList = function() {
	var id = DirectBox2d.BodyGetFixtureList(this.id);
	var fix = new b2.Fixture(id);
	return fix;
}
b2.Body.prototype.IsActive = function() {
	var active=DirectBox2d.BodyIsActive(this.id);
	return active;
}
b2.Body.prototype.IsAwake = function() {
	var awake=DirectBox2d.BodyIsAwake(this.id);
	return awake;
}

// BodyDef
b2.BodyDef.prototype = {
	get type() {
		return DirectBox2d.BodyDefGetType(this.id);
	}, 
	set type(val) {
		DirectBox2d.BodyDefSetType(this.id, val);
	},
	get position() {
		DirectBox2d.BodyDefGetPosition(this.id, this._position);
		return this._position;
		/*
		var id = DirectBox2d.BodyDefGetPosition(this.id);
		var x=DirectBox2d.Vec2GetX(id);
		var y=DirectBox2d.Vec2GetY(id);
		var p=new b2.Vec2(x, y, id);
		return p;*/
	}, 
	set position(val) {
		this.position=val;
		DirectBox2d.BodyDefSetPosition(this.id, this.position);
	},
	get angle() {
		return DirectBox2d.BodyDefGetAngle(this.id);
	}, 
	set angle(val) {
		DirectBox2d.BodyDefSetAngle(this.id, val);
	},
	get linearVelocity() {
		var vec = DirectBox2d.BodyDefGetLinearVelocity(this.id);
		return vec;
		/*var id = DirectBox2d.BodyDefGetLinearVelocity(this.id);
		var x=DirectBox2d.Vec2GetX(id);
		var y=DirectBox2d.Vec2GetY(id);
		var p=new b2.Vec2(x, y, id);
		return p;*/
	}, 
	set linearVelocity(val) {
		DirectBox2d.BodyDefSetLinearVelocity(this.id, val.id);
	},
	get angularVelocity() {
		return DirectBox2d.BodyDefGetAngularVelocity(this.id);
	}, 
	set angularVelocity(val) {
		DirectBox2d.BodyDefSetAngularVelocity(this.id, val);
	},
	get linearDamping() {
		return DirectBox2d.BodyDefGetLinearDamping(this.id);
	}, 
	set linearDamping(val) {
		DirectBox2d.BodyDefSetLinearDamping(this.id, val);
	},
	get angularDamping() {
		return DirectBox2d.BodyDefGetAngularDamping(this.id);
	}, 
	set angularDamping(val) {
		DirectBox2d.BodyDefSetAngularDamping(this.id, val);
	},
	get awake() {
		if(DirectBox2d.BodyDefGetAwake(this.id))
			return true;
		else
			return false;
	}, 
	set awake(val) {
		var awake=(vale)?1:0;
		DirectBox2d.BodyDefSetAllowSleep(this.id, awake);
	},
	get allowSleep() {
		if(DirectBox2d.BodyDefGetAllowSleep(this.id))
			return true;
		else
			return false;
	}, 
	set allowSleep(val) {
		if(val!=true)
			DirectBox2d.BodyDefSetAllowSleep(this.id, 0);
		else
			DirectBox2d.BodyDefSetAllowSleep(this.id, 1);
	},
	get userData() {
		//return DirectBox2d.BodyDefGetUserData(this.id);
		return JSON.parse(this._userData);
	},
	set userData(val) {
		this._userData = JSON.stringify(val);
		//DirectBox2d.BodyDefSetUserData(this.id, JSON.stringify(val));
	}
}
// Contact
b2.Contact.prototype.GetFixtureA = function() {
	var id = DirectBox2d.ContactGetFixtureA(this.id);
	return new b2.Fixture(id);
}
b2.Contact.prototype.GetFixtureB = function() {
	var id = DirectBox2d.ContactGetFixtureB(this.id);
	return new b2.Fixture(id);
}
// ContactListener
b2.ContactListener.prototype = {
	get BeginContact() {
		return undefined;
	}, 
	set BeginContact(val) {
		DirectBox2d.ContactListenerSetBeginContact(this.id, val.toString());
	}
}

// CircleShape
b2.CircleShape.prototype.SetRadius = function(_r) {
	DirectBox2d.CircleShapeSetRadius(this.id, _r);
}
b2.CircleShape.prototype.GetRadius = function() {
	return DirectBox2d.CircleShapeGetRadius(this.id);
}
b2.CircleShape.prototype.GetPosition = function() {
	var vec = DirectBox2d.CircleShapeGetPosition(this.id);
	return vec;
}

// fixture
b2.Fixture.prototype = {
	get shape() {
		return DirectBox2d.FixtureGetShape(this.id);
	},
}
b2.Fixture.prototype.GetBody = function() {
	var id = DirectBox2d.FixtureGetBody(this.id);
	var b=new b2.Body(0, 0, id);
	return b;
}
b2.Fixture.prototype.GetNext = function() {
	var id = DirectBox2d.FixtureGetNext(this.id);
	if(id) {
		var b=new b2.Fixture(id);
		return b;
	} else {
		return undefined;
	}
}

// FixtureDef
b2.FixtureDef.prototype = {
	get shape() {
		return DirectBox2d.FixtureDefGetShape(this.id);
		/*var id = DirectBox2d.FixtureDefGetShape(this.id);
		var shapeType = DirectBox2d.FixtureDefGetShapeType(this.id);
		var shape;
		if(shapeType==0) {
			shape=new b2.CircleShape(id);
		} else {
			// shape=new b2.Shape(x, y, id);
		} 
		return shape;*/
	}, 
	set shape(val) {
		DirectBox2d.FixtureDefSetShape(this.id, val.id);
	},
	get friction() {
		return DirectBox2d.FixtureDefGetFriction(this.id);
	}, 
	set friction(val) {
		DirectBox2d.FixtureDefSetFriction(this.id, val);
	},
	get density() {
		return DirectBox2d.FixtureDefGetDensity(this.id);
	}, 
	set density(val) {
		DirectBox2d.FixtureDefSetDensity(this.id, val);
	},
	get restitution() {
		return DirectBox2d.FixtureDefGetRestitution(this.id);
	}, 
	set restitution(val) {
		DirectBox2d.FixtureDefSetRestitution(this.id, val);
	},
}
// PolygonShape

b2.PolygonShape.prototype.SetAsBox = function(hx, hy) {
	DirectBox2d.PolygonShapeSetAsBox(this.id, hx, hy);
}
b2.PolygonShape.prototype.GetVertexCount = function() {
	return DirectBox2d.PolygonShapeGetVertexCount(this.id);
}
b2.PolygonShape.prototype.GetVertex = function(index) {
	return DirectBox2d.PolygonShapeGetVertex(this.id, index);
}

// Vec2 is implemented in native side now.

// World
b2.World.prototype.CreateBody = function(bodyDef) {
	var id=bodyDef.id;
	var bid=DirectBox2d.WorldCreateBody(this.id, id);
	if(typeof bodyDef._userData != "undefined") {
		DirectBox2d.BodySetUserData(bid, bodyDef._userData);
	}
	var body=new b2.Body(0, 0, bid);
	return body;
}
b2.World.prototype.DestroyBody = function(body) {
	var id=body.id;
	var bid=DirectBox2d.WorldDestroyBody(this.id, id);
}
b2.World.prototype.SetContactListener = function(cl) {
	var id=cl.id;
	DirectBox2d.WorldSetContactListener(this.id, id);
}
b2.World.prototype.Step = function(tick, vIterations, pIterations) {
	DirectBox2d.WorldStep(this.id, tick, vIterations, pIterations);
}
b2.World.prototype.GetBodyList = function() {
	var id = DirectBox2d.WorldGetBodyList(this.id);
	var b=new b2.Body(0, 0, id);
	return b;
}

// DebugDraw code is taken mostly from the box2dWeb version
b2.World.prototype.SetDebugDraw = function (debugDraw) {
	this.m_debugDraw = debugDraw;
}

b2.World.prototype.DrawDebugData = function () {
      if (this.m_debugDraw == null) {
         return;
      }
      this.m_debugDraw.m_sprite.graphics.clear();
      var flags = this.m_debugDraw.GetFlags();
      var i = 0;
      var b;
      var f;
      var s;
      var j;
      var bp;
      var xf;
      var color = new b2.Color(0, 0, 0);  
         if (flags & e_shapeBit) {    
      
      	for (b = this.GetBodyList(); b; b = b.GetNext()) {
            xf = b.GetTransform();
            for (f = b.GetFixtureList(); f; f = f.GetNext()) {
               s = f.shape;
               if (b.IsActive() == false) {
                  color.Set(0.5, 0.5, 0.3);
                  this.DrawShape(s, xf, color);
               }
               else if (b.GetType() == b2.Body.b2_staticBody) {
                  color.Set(0.5, 0.9, 0.5);
                  this.DrawShape(s, xf, color);
               }
               else if (b.GetType() == b2.Body.b2_kinematicBody) {
                  color.Set(0.5, 0.5, 0.9);
                  this.DrawShape(s, xf, color);
               }
               else if (b.IsAwake() == false) {
                  color.Set(0.6, 0.6, 0.6);
                  this.DrawShape(s, xf, color);
               }
               else {
                  color.Set(0.9, 0.7, 0.7);
                  this.DrawShape(s, xf, color);
               }
            }
         }
      }
/*
	//:TODO 
      if (flags & b2DebugDraw.e_jointBit) {
         for (j = this.m_jointList;
         j; j = j.m_next) {
            this.DrawJoint(j);
         }
      }
      if (flags & b2DebugDraw.e_controllerBit) {
         for (var c = this.m_controllerList; c; c = c.m_next) {
            c.Draw(this.m_debugDraw);
         }
      }
      if (flags & b2DebugDraw.e_pairBit) {
         color.Set(0.3, 0.9, 0.9);
         for (var contact = this.m_contactManager.m_contactList; contact; contact = contact.GetNext()) {
            var fixtureA = contact.GetFixtureA();
            var fixtureB = contact.GetFixtureB();
            var cA = fixtureA.GetAABB().GetCenter();
            var cB = fixtureB.GetAABB().GetCenter();
            this.m_debugDraw.DrawSegment(cA, cB, color);
         }
      }
      if (flags & b2DebugDraw.e_aabbBit) {
         bp = this.m_contactManager.m_broadPhase;
         vs = [new b2Vec2(), new b2Vec2(), new b2Vec2(), new b2Vec2()];
         for (b = this.m_bodyList;
         b; b = b.GetNext()) {
            if (b.IsActive() == false) {
               continue;
            }
            for (f = b.GetFixtureList();
            f; f = f.GetNext()) {
               var aabb = bp.GetFatAABB(f.m_proxy);
               vs[0].Set(aabb.lowerBound.x, aabb.lowerBound.y);
               vs[1].Set(aabb.upperBound.x, aabb.lowerBound.y);
               vs[2].Set(aabb.upperBound.x, aabb.upperBound.y);
               vs[3].Set(aabb.lowerBound.x, aabb.upperBound.y);
               this.m_debugDraw.DrawPolygon(vs, 4, color);
            }
         }
      }
      if (flags & b2.DebugDraw.e_centerOfMassBit) {
         for (b = this.m_bodyList;
         b; b = b.m_next) {
            xf = b2.World.s_xf;
            xf.R = b.GetTransform().R;
            xf.position = b.GetWorldCenter();
            this.m_debugDraw.DrawTransform(xf);
         }
      }
      */
}

b2.World.prototype.DrawShape = function (shape, xf, color) {
    if(shape instanceof b2.CircleShape) {
		var circle = shape;//((shape instanceof b2.CircleShape ? shape : null));
		var center = b2.Math.Mul(xf, circle.GetPosition());
        var radius = circle.GetRadius();
        // avoid making new vec! var axis = new b2.Vec2(xf.q.c, xf.q.s);// rotate the q vector  //was xf.R.col1;
        this.m_debugDraw.DrawSolidCircle(center, radius, xf.q.c, xf.q.s, color);
	}
    if(shape instanceof b2.PolygonShape) {
        var i = 0;
        var poly = shape;//((shape instanceof b2.PolygonShape ? shape : null));
        var vertexCount = parseInt(poly.GetVertexCount());
        var vertices = new Array(vertexCount);
        for (i = 0; i < vertexCount; ++i) {
           vertices[i] = b2.Math.Mul(xf, poly.GetVertex(i));
        }
        this.m_debugDraw.DrawSolidPolygon(vertices, vertexCount, color);
     }
      /*case b2Shape.e_edgeShape:
         {
            var edge = (shape instanceof b2EdgeShape ? shape : null);
            this.m_debugDraw.DrawSegment(b2Math.MulX(xf, edge.GetVertex1()), b2Math.MulX(xf, edge.GetVertex2()), color);
         }
         break;*/
}
// Math
	b2.Math={};
	b2.Math.Clamp = function (a, low, high) {
		if (a === undefined) a = 0;
    	if (low === undefined) low = 0;
    	if (high === undefined) high = 0;
		return a < low ? low : a > high ? high : a;
	}
	b2.Math.Mul = function (T, v) {
		var x = (T.q.c * v.x - T.q.s * v.y) + T.p.x;
		var y = (T.q.s * v.x + T.q.c * v.y) + T.p.y;
		return new b2.Vec2(x, y);
	}

// Color
	b2.Color = function (rr, gg, bb) {
		if (rr === undefined) rr = 0;
      	if (gg === undefined) gg = 0;
      	if (bb === undefined) bb = 0;
      	this.r = parseInt(255 * b2.Math.Clamp(rr, 0.0, 1.0));
      	this.g = parseInt(255 * b2.Math.Clamp(gg, 0.0, 1.0));
      	this.b = parseInt(255 * b2.Math.Clamp(bb, 0.0, 1.0));
	}
	b2.Color.prototype = {
		get color() {
			return (this.r << 16) | (this.g << 8) | (this.b);
		}
	}
	
	b2.Color.prototype.Set = function (rr, gg, bb) {
    	if (rr === undefined) rr = 0;
      	if (gg === undefined) gg = 0;
      	if (bb === undefined) bb = 0;
      	this.r = parseInt(255 * b2.Math.Clamp(rr, 0.0, 1.0));
      	this.g = parseInt(255 * b2.Math.Clamp(gg, 0.0, 1.0));
      	this.b = parseInt(255 * b2.Math.Clamp(bb, 0.0, 1.0));
   }
   
// DebugDraw

    e_shapeBit = 0x0001;
    e_jointBit = 0x0002;
    e_aabbBit = 0x0004;
    e_pairBit = 0x0008;
    e_centerOfMassBit = 0x0010;
	e_controllerBit = 0x0020;

   b2.DebugDraw.b2DebugDraw = function () {
      this.m_drawScale = 1.0;
      this.m_lineThickness = 1.0;
      this.m_alpha = 1.0;			//:TODO - alpha is not supported now, need to review/change canvas fill, stroke implementation
      this.m_fillAlpha = 1.0;		// 		since currently only global alpha is used.
      this.m_xformScale = 1.0;
      var __this = this;
      //#WORKAROUND
      this.m_sprite = {
         graphics: {
            clear: function () {
               //__this.m_ctx.clearRect(0, 0, __this.m_ctx.canvas.width, __this.m_ctx.canvas.height)
               __this.m_ctx.clear();
            }
         }
      };
   };
   b2.DebugDraw.prototype._color = function (color, alpha) {
      return "rgba(" + ((color & 0xFF0000) >> 16) + "," + ((color & 0xFF00) >> 8) + "," + (color & 0xFF) + "," + alpha + ")";
   };
   b2.DebugDraw.prototype.b2DebugDraw = function () {
      this.m_drawFlags = 0;
   };
   b2.DebugDraw.prototype.SetFlags = function (flags) {
      if (flags === undefined) flags = 0;
      this.m_drawFlags = flags;
   };
   b2.DebugDraw.prototype.GetFlags = function () {
      return this.m_drawFlags;
   };
   b2.DebugDraw.prototype.AppendFlags = function (flags) {
      if (flags === undefined) flags = 0;
      this.m_drawFlags |= flags;
   };
   b2.DebugDraw.prototype.ClearFlags = function (flags) {
      if (flags === undefined) flags = 0;
      this.m_drawFlags &= ~flags;
   };
   b2.DebugDraw.prototype.SetSprite = function (sprite) {
      this.m_ctx = sprite;
   };
   b2.DebugDraw.prototype.GetSprite = function () {
      return this.m_ctx;
   };
   b2.DebugDraw.prototype.SetDrawScale = function (drawScale) {
      if (drawScale === undefined) drawScale = 0;
      this.m_drawScale = drawScale;
   };
   b2.DebugDraw.prototype.GetDrawScale = function () {
      return this.m_drawScale;
   };
   b2.DebugDraw.prototype.SetLineThickness = function (lineThickness) {
      if (lineThickness === undefined) lineThickness = 0;
      this.m_lineThickness = lineThickness;
      this.m_ctx.strokeWidth = lineThickness;
   };
   b2.DebugDraw.prototype.GetLineThickness = function () {
      return this.m_lineThickness;
   };
   b2.DebugDraw.prototype.SetAlpha = function (alpha) {
      if (alpha === undefined) alpha = 0;
      this.m_alpha = alpha;
   };
   b2.DebugDraw.prototype.GetAlpha = function () {
      return this.m_alpha;
   };
   b2.DebugDraw.prototype.SetFillAlpha = function (alpha) {
      if (alpha === undefined) alpha = 0;
      this.m_fillAlpha = alpha;
   };
   b2.DebugDraw.prototype.GetFillAlpha = function () {
      return this.m_fillAlpha;
   };
   b2.DebugDraw.prototype.SetXFormScale = function (xformScale) {
      if (xformScale === undefined) xformScale = 0;
      this.m_xformScale = xformScale;
   };
   b2.DebugDraw.prototype.GetXFormScale = function () {
      return this.m_xformScale;
   };
   b2.DebugDraw.prototype.DrawPolygon = function (vertices, vertexCount, color) {
      if (!vertexCount) return;
      var s = this.m_ctx;
      var drawScale = this.m_drawScale;
      s.beginPath();
      s.strokeStyle = this._color(color.color, this.m_alpha);
      s.moveTo(vertices[0].x * drawScale, vertices[0].y * drawScale);
      for (var i = 1; i < vertexCount; i++) {
         s.lineTo(vertices[i].x * drawScale, vertices[i].y * drawScale);
      }
      s.lineTo(vertices[0].x * drawScale, vertices[0].y * drawScale);
      s.closePath();
      s.stroke();
   };
   b2.DebugDraw.prototype.DrawSolidPolygon = function (vertices, vertexCount, color) {
      if (!vertexCount) return;
      var s = this.m_ctx;
      var drawScale = this.m_drawScale;
      s.beginPath();
      s.strokeStyle = this._color(color.color, this.m_alpha);
      s.fillStyle = this._color(color.color, this.m_fillAlpha);
      s.moveTo(vertices[0].x * drawScale, vertices[0].y * drawScale);
      for (var i = 1; i < vertexCount; i++) {
         s.lineTo(vertices[i].x * drawScale, vertices[i].y * drawScale);
      }
      s.lineTo(vertices[0].x * drawScale, vertices[0].y * drawScale);
      s.closePath();
      s.fill();
      s.stroke();
   };
   b2.DebugDraw.prototype.DrawCircle = function (center, radius, color) {
      if (!radius) return;
      var s = this.m_ctx;
      var drawScale = this.m_drawScale;
      s.beginPath();
      s.strokeStyle = this._color(color.color, this.m_alpha);
      s.arc(center.x * drawScale, center.y * drawScale, radius * drawScale, 0, Math.PI * 2, true);
      s.closePath();
      s.stroke();
   };
   b2.DebugDraw.prototype.DrawSolidCircle = function (center, radius, axis_x, axis_y, color) {
		//console.log("radius = "+radius);
		if (!radius) return;
		var s = this.m_ctx,
		drawScale = this.m_drawScale,
		cx = center.x * drawScale,
		cy = center.y * drawScale;
		s.moveTo(0, 0);
	   	s.beginPath();
	   	s.strokeStyle = this._color(color.color, this.m_alpha);
		s.fillStyle = this._color(color.color, this.m_fillAlpha);
		s.arc(cx, cy, radius * drawScale, 0, Math.PI * 2, true);
		s.moveTo(cx, cy);
		s.lineTo((center.x + axis_x * radius) * drawScale, (center.y + axis_y * radius) * drawScale);
		s.closePath();
		s.fill();
		s.stroke();
   };
   b2.DebugDraw.prototype.DrawSegment = function (p1, p2, color) {
      var s = this.m_ctx,
      drawScale = this.m_drawScale;
      s.strokeStyle = this._color(color.color, this.m_alpha);
      s.beginPath();
      s.moveTo(p1.x * drawScale, p1.y * drawScale);
      s.lineTo(p2.x * drawScale, p2.y * drawScale);
      s.closePath();
      s.stroke();
   };
   b2.DebugDraw.prototype.DrawTransform = function (xf) {
      var s = this.m_ctx,
      drawScale = this.m_drawScale;
      s.beginPath();
      s.strokeStyle = this._color(0xff0000, this.m_alpha);
      
      /* 
      - modified below.  Kept this only for comparison, remove this block after testing 
      s.moveTo(xf.position.x * drawScale, xf.position.y * drawScale);
      s.lineTo((xf.position.x + this.m_xformScale * xf.R.col1.x) * drawScale, (xf.position.y + this.m_xformScale * xf.R.col1.y) * drawScale);

      s.strokeStyle = this._color(0xff00, this.m_alpha);
      s.moveTo(xf.position.x * drawScale, xf.position.y * drawScale);
      s.lineTo((xf.position.x + this.m_xformScale * xf.R.col2.x) * drawScale, (xf.position.y + this.m_xformScale * xf.R.col2.y) * drawScale);
      - To here
      */
      s.moveTo(xf.p.x * drawScale, xf.p.y * drawScale);
      s.lineTo((xf.p.x + this.m_xformScale * xf.q.c) * drawScale, (xf.p.y + this.m_xformScale * xf.q.s) * drawScale);

      s.strokeStyle = this._color(0xff00, this.m_alpha);
      s.moveTo(xf.p.x * drawScale, xf.p.y * drawScale);
      s.lineTo((xf.p.x - this.m_xformScale * xf.q.s) * drawScale, (xf.p.y + this.m_xformScale * xf.q.c) * drawScale);
      
      s.closePath();
      s.stroke();
   };
