var __h = 800, __w = 800;
//var screenCanvas = new Canvas(__w, __h, true);  // use this to initialize to a certain H, W
var screenCanvas = new CanvasConstructor(0, 0, true);        // use 0, 0 to initialize to screen size 
//screenCanvas.log('var screenCanvas = new Canvas(800, 800, true);');

var appMobiCachedFonts=[];
var appMobiCachedFontsMax=5; // set maximum number of cached fonts
var appMobiLastFontSet;

AppMobiImage = function(source) {
	var _s = '';
	var _h = 0;
	var _w = 0;
	var _id;
	var _c = false;
	var nativeIm;
	var _onerror = function(){};
	var _onload = function(){};
	var _error = '';

	if(typeof source!="undefined") { 
		nativeIm = new nativeImage(source); // use w, h if they will be used in Image Constructor
		_id = nativeIm.id;
		_h = nativeIm.h;
		_w = nativeIm.w;
		_s = source;
			
		if(nativeIm.err == false) {
			_c = true;
			_error = '';
			_onload();
		}else{
			_c = false;
			_error = nativeIm.errDescription;
			_onerror();
		}
		
	} //:TODO make it work if source was not given
	var retval = {
		get id () {
			return _id;
		},
		set src (s) {
			_s = s;
			nativeIm = new nativeImage(s);
			_id = nativeIm.id;
			_h = nativeIm.h;
			_w = nativeIm.w;
			//console.log('_id:'+_id+' _s:'+_s+' _h:'+_h+' _w:'+_w+' nativeIm.id:'+nativeIm.id+' nativeIm.h:'+nativeIm.h+' nativeIm.w:'+nativeIm.w)
			
			if(nativeIm.err == false) {
				_c = true;
				_error = '';
				_onload();
			}else{
				_c = false;
				_error = nativeIm.errDescription;
				_onerror();
			}
				
		},
		get src () {
			return _s;
		},
		set height (h) {
			_h = h;
			screenCanvas.setImageHeight(this.id, h); // not implemented yet!
		},
		get height () {
			return _h;
		},
		set width (w) {
			_w = w;
			screenCanvas.setImageWidth(this.id, w); // not implemented yet!
		},
		get width () {
			return _w;
		},
		get complete () {
			return _c;
		},
		set onload(f) {
			_onload = f;
		},
		set onerror(f) {
			_onerror = f;
		},
		get error() {
			return _error;
		},	
		hintLoad: function() {
			if(_id) {
				//screenCanvas.hintLoad(_id);
			}
		},
		hintUnload: function() {
			if(_id) {
				//screenCanvas.hintUnload(_id);
			}
		}
	}
	return retval;
};

Image = AppMobiImage;

AppMobiAudio = function(source) {
	var _s = '';
	var _id = 0;
	var _loop = false;
	var _volume = 1;
	var nativeAud;
	
	if(typeof source!="undefined") { 
		nativeAud = new nativeAudio(source);
		_id = nativeAud.id;
		//console.log("Create Audio id = "+_id);
		_s = source;
	} //:TODO make it work if source was not given
	var retval = {
		set src (source) {
			nativeAud = new nativeAudio(source);
			_id = nativeAud.id;
			//console.log("Create Audio id = "+_id);
			_s = source;
			if(this.onload) {
				console.log('AppMobiAudio onload()');
				this.onload();
			}
		},
		get src () {
			return _s;
		},
		set loop (loop) { // not implemented
			_loop = loop;
		},
		get loop () {
			return _loop;
		},
		set volume (vol) {
			_volume = vol;
			nativeAud.audioSetVolume(_id, vol);
		},
		get volume () {
			return _volume;
		},
		set currentTime (time) {
			//console.log("Setting time to = "+time);
			nativeAud.audioSetCurrentTime(_id, time);
		},
		get currentTime () {
			return nativeAud.audioGetCurrentTime(_id);
		},
		play: function() {  
			//console.log("Play Audio id = "+_id+" "+_loop);
			nativeAud.audioPlay(_id, _loop);
		},
		pause: function() {  
			nativeAud.audioPause(_id);
		},
		stop: function() {
			nativeAud.audioStop(_id);
		},
		load: function() {  
			nativeAud.audioLoad(_id);
		},
		canPlayType: function(type) {
			//valid return types are 'probably', 'maybe' and ''
			//for now, indicate that we only support 'audio/mpeg', 'audio/wav' and 'audio/x-wav'
			if(type=='audio/mpeg' || type=='audio/wav' || type=='audio/x-wav') {
				return 'probably';
			} else {
				return '';
			}
		},
		get paused () {
			return nativeAud.isAudioPaused(_id);
		},
		get duration () {
			return nativeAud.audioDuration(_id);
		}
	}
	return retval;
};

Audio = AppMobiAudio;

AppMobi = function() {
	var listeners = {}; //for canvas
	return {
		
		canvas: {
			context: function() {
			},
			getContext: function() {return new this.context(screenCanvas);},
			set height(h) {
				return screenCanvas.setHeight(h);
			},
			get height() {
				return screenCanvas.getHeight();
			},
			set width(w) {
				return screenCanvas.setWidth(w);
			},
			get width() {
				return screenCanvas.getWidth();
			},
			addEventListener: function(type, listener, useCapture){
				if(listeners[type]) {
					listeners[type].push(listener);
				} else {
					listeners[type] = [listener];
				}
			},
			removeEventListener: function(type, listener, useCapture){
				if(listeners[type]) {
					listeners[type].pop(listener);
				}
				if(listeners[type].length==0) {
					delete listeners[type];
				}
			},
			fireEvent: function(event) {
				var listenersForType = listeners[event.type];
				if(listenersForType) {
					for(var i=0;i<listenersForType.length;i++) {
						listenersForType[i](event);
					}
				}
			},
			dispatchEvent: function(event){this.fireEvent(event);}
		},
		box2d: {
		},
		//setup webview - provides access to parent AppMobiWebView
		webview: {
			//webview.execute to execute javascript in webview
			execute: function(js){
				screenCanvas.execute(js);
			}
		},
		
		isnative: true  //internal only
	}
}();

DContext = function(dCanvas) {
	this.directCanvas = dCanvas;
	this._maxTexMem = 100*1024*1024; // default value
};
AppMobi.canvas.context = DContext;

DContext.prototype = {
	get fillStyle() {
		return this._fillStyle;
	}, 
	set fillStyle(val) {
		this.directCanvas.setFillStyle(val);
		this._fillStyle=val;
	},
	get clearStyle() {
		return this._clearStyle;
	}, 
	set clearStyle(val) {
		this.directCanvas.setClearStyle(val);
		this._clearStyle=val;
	},
	get strokeStyle() {
		return this._strokeStyle;
	}, 
	set strokeStyle(val) {
		this.directCanvas.setStrokeStyle(val);
		this._strokeStyle=val;
	},
	get globalAlpha() {
		return this.directCanvas.getGlobalAlpha();
	}, 
	set globalAlpha(val) {
		this.directCanvas.setGlobalAlpha(val);
	},
	get samplingMode() {
		return this.directCanvas.getTextureSamplingMode();
	}, 
	set samplingMode(val) {
		this.directCanvas.setTextureSamplingMode(val);
	},
	get globalCompositeOperation() {
		return "get globalComposite Not Implemented!";
	}, 
	set globalCompositeOperation(val) {
		this.directCanvas.setGlobalCompositeOperation(val);
	},
	get font() {
		return this.appMobiCanvasFont;
	}, 
	set font(name) {
		appMobiLastFontSet = name;
		var parsedFont=appMobiParseFont(name);
		
		//:Later - Do we need to make a default font to make it work if font is not set? 
		this.appMobiCanvasFont = this.setFont(parsedFont.fontFamily, parsedFont.fontSize, this._fillStyle);
	},
	// returns total memory used by opengl textures (for fonts and images) 
	get texMemUsed() {
		return this.directCanvas.getTexMemUsed();
	},
	// maximum amount that's ok to be used by opengl textures
	get maxTexMem() {
		return this._maxTexMem;
	}, 
	set maxTexMem(val) {
		this._maxTexMem = val;
		console.log("setting max tex mem: "+this._maxTexMem);
	},
}

// This function is originally based on http://stackoverflow.com/questions/5618676/how-to-parse-css-font-shorthand-format
function appMobiParseFont(font)
{
    var fontFamily = null,
        fontSize = null,
        fontStyle = "normal",
        fontWeight = "normal",
        fontVariant = "normal",
        lineHeight = "normal";

    var elements = font.split(/\s+/);
    outer: while (element = elements.shift())
    {
        switch (element)
        {
            case "normal":
                break;

            case "italic":
            case "oblique":
                fontStyle = element;
                break;

            case "small-caps":
                //fontVariant = element;
                break;

            case "bold":
            case "bolder":
            case "lighter":
            case "100":
            case "200":
            case "300":
            case "400":
            case "500":
            case "600":
            case "700":
            case "800":
            case "900":
                fontWeight = element;
                break;

            default:
                if (!fontSize) {
                    var parts = element.split("/");
                    fontSize = parts[0];
					fontSize = parseFloat(fontSize);
					//TODO - Handle size correctly
					//currently just take the first piece as size, parsing out the numeric value
                    if (parts.length > 1) lineHeight = parts[1];
                    break;
                }

				fontFamily = element;
				if (elements.length) {
                    fontFamily += " " + elements.join(" ");
				}
				//todo: handle fontfamily fallthrough
				//currently just take the first listed as fontName
                break outer;
        }
    }
    if(!fontSize) {
    	fontSize=32; // set default
    }

    return {
        "fontStyle": fontStyle,
        "fontVariant": fontVariant,
        "fontWeight": fontWeight,
        "fontSize": fontSize,
        "lineHeight": lineHeight,
        "fontFamily": fontFamily
    }
}

appMobiJSFont = function(name, font, size, fillStyle) {
	this.name=name;
	this.font=font;
	this.size=size;
	this.fillStyle=fillStyle;
	this.age=0;		// to track Least Recently Used font for caching, bigger number means younger!
	this.sameFont = function(name, size, fillStyle) {
		if(name===this.name && size===this.size && fillStyle===this.fillStyle) {
			return this.font;
		} else {
			return 0;
		}
	}
}
DContext.prototype.setFont = function(name, size, fillStyle) {
	// search if the font and style exists in array or not
	// return it if already exists
	// console.log("set font: "+name+", "+size+", "+fillStyle);
	var maxAge=0, minAge=0, minIndex=0;
	if(appMobiCachedFonts.length) {
		maxAge=minAge=appMobiCachedFonts[0].age;
	}
	for(var i=0; i<appMobiCachedFonts.length; i++) {
		var jsFont=appMobiCachedFonts[i];
		var font=jsFont.sameFont(name, size, fillStyle);
		if(jsFont.age>maxAge)
			maxAge=jsFont.age;
		if(jsFont.age<minAge) {
			minAge=jsFont.age;
			minIndex=i;	// index to the oldest item
			}
		if(font) {
			jsFont.age=maxAge+1; // make it newest.  (This could overflow after 2^53!)
			return font;
		}
	}
	// if not and array not reached max create and put in array
	if(appMobiCachedFonts.length<appMobiCachedFontsMax) {
		// console.log("making new font: "+name+", size = "+size+", fillStyle = "+fillStyle);
		var font = new appMobiFont(name, size, fillStyle);
		appMobiCachedFonts[appMobiCachedFonts.length] = new appMobiJSFont(name, font, size, fillStyle);
		appMobiCachedFonts[appMobiCachedFonts.length-1].age=maxAge+1; // make it newest
		return font;
	}
	// otherwise create and replace the oldest used in array
	var font = new appMobiFont(name, size, fillStyle);
	appMobiCachedFonts[minIndex] = new appMobiJSFont(name, font, size, fillStyle);
	appMobiCachedFonts[minIndex].age=maxAge+1; // make it newest
	return font;
}

DContext.prototype.present = function() {
	//console.log("Tex Mem Used = "+ this.texMemUsed);
	if(this.texMemUsed > this._maxTexMem)
	{
		console.log("!!!!! Initiating Garbage Collection");
		gc();
	}
	this.directCanvas.present();
}
DContext.prototype.getContext = function() {
	return this.directCanvas;
}

DContext.prototype.save = function() {
	this.directCanvas.save();
}
DContext.prototype.restore = function() {
	this.directCanvas.restore();
}
DContext.prototype.scale = function(x, y) {
	this.directCanvas.scale(x, y);
}
DContext.prototype.rotate = function(a) {
	this.directCanvas.rotate(a);
}
DContext.prototype.translate = function(x, y) {
	this.directCanvas.translate(x, y);
}
DContext.prototype.clear = function() {
	this.directCanvas.clear();
}
DContext.prototype.fillRect = function(x, y, w, h) {
	this.directCanvas.fillRect(x, y, w, h);
}
DContext.prototype.strokeRect = function(x, y, w, h) {
	this.directCanvas.strokeRect(x, y, w, h);
}
DContext.prototype.clearRect = function(x, y, w, h) {
	this.directCanvas.clearRect(x, y, w, h);
}
DContext.prototype.drawImageTile = function(image, x, y, t, w, h, flipx, flipy, a) {
	if(typeof a != 'undefined') {
		this.directCanvas.drawImageTile(image.id, x, y, t, w, h, flipx, flipy, a);
	} else if(typeof h != 'undefined') {
		this.directCanvas.drawImageTile(image.id, x, y, t, w, h, flipx, flipy);
	} else {
		this.directCanvas.drawImageTile(image.id, x, y, t); // t is alpha here
	}
}
DContext.prototype.drawRotatedImage = function(image, x, y, w, h, x2, y2, w2, h2, tx, ty, angle) {
		this.directCanvas.drawRotatedImage(image.id, x, y, w, h, x2, y2, w2, h2, tx, ty, angle);
}

DContext.prototype.createPattern= function(image, direction) {
 	return this.directCanvas.createPattern(image, direction);
}

DContext.prototype.drawImage = function(image, x, y, w, h, x2, y2, w2, h2) {
	var im;
	if(typeof image.id == 'undefined') {
		im = image.getContext().directCanvas; // it's a canvas object
	} else {
		im = image.id;  // it's an id of an image
	}
	if(typeof x2 != 'undefined') {
		this.directCanvas.drawImage(im, x, y, w, h, x2, y2, w2, h2);
	} else if(typeof w != 'undefined') {
		this.directCanvas.drawImage(im, x, y, w, h);
	} else {
		this.directCanvas.drawImage(im, x, y);
	}
}
DContext.prototype.getImageData = function(x, y, w, h) {
	return this.directCanvas.getImageData(x, y, w, h);
}

DContext.prototype.beginPath = function() {
	this.directCanvas.beginPath();
}
DContext.prototype.closePath = function() {
	this.directCanvas.closePath();
}
DContext.prototype.moveTo = function(x, y) {
	this.directCanvas.moveTo(x, y);
}
DContext.prototype.lineTo = function(x, y) {
	this.directCanvas.lineTo(x, y);
}
DContext.prototype.quadraticCurveTo = function(cpx, cpy, x, y) {
	this.directCanvas.quadraticCurveTo(cpx, cpy, x, y);
}
DContext.prototype.bezierCurveTo = function(cp1x, cp1y, cp2x, cp2y, x, y) {
	this.directCanvas.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
}
DContext.prototype.arcTo = function(x1, y1, x2, y2, radius) {
	this.directCanvas.arcTo(x1, y1, x2, y2, radius);
}
DContext.prototype.arc = function(dx, dy, radius, sangle, eangle, anticlock) {
	this.directCanvas.arc(dx, dy, radius, sangle, eangle, anticlock);
}
DContext.prototype.rect = function(x, y, w, h) {
	this.directCanvas.rect(x, y, w, h);
}
DContext.prototype.fill = function() {
	this.directCanvas.fill();
}
DContext.prototype.stroke = function() {
	this.directCanvas.stroke();
}

DContext.prototype.fillText = function(font, text, x, y) {
	// if font is not explictly given use this context's font
	// Note: only checking number of arguments here, will be more robust to check 
	// type of font
	if(arguments.length<4) {
		// font not sent as argument
		//console.log("fillText font: "+appMobiLastFontSet);
		this.font=appMobiLastFontSet;
		this.directCanvas.fillText(this.font.id, font, text, x);  // names of arguments convoluted here, font is text etc!
	} else {
		this.directCanvas.fillText(font.id, text, x, y);
	}
}

DContext.prototype.measureText = function(font, text) {
	// if font is not explictly given use this context's font
	// Note: only checking number of arguments here, will be more robust to check 
	// type of font
	if(arguments.length<2) {
		// font not sent as argument
		//console.log("fillText font: "+appMobiLastFontSet);
		this.font=appMobiLastFontSet;
		return this.directCanvas.measureText(this.font.id, font);  // names of arguments convoluted here, font is text etc!
	} else {
		return this.directCanvas.measureText(font.id, text);
	}
}

DContext.prototype.setTextureMemory = function(mode,param) {
	if(arguments.length < 2) {
		return;
	}
	
	if(!(typeof mode === 'number' && (mode == 0 || mode == 1))) {
		return;
	}
	
	if(!(typeof param === 'number')) {
		return;
	}
	
	this.directCanvas.setTextureMemory(mode, param);
}

AppMobiContext = function(){
	this.sounds = [];
	this.audio = null;
}

AppMobiContext.prototype.include = function(file) {
	screenCanvas.include(file);
}

AppMobiContext.prototype.pathToString = function(file) {
	return screenCanvas.pathToString(file);
}

AppMobiContext.prototype.startBackgroundSound = function(relativeUrl, looping) {
	if(this.audio == null) this.audio = new Audio(relativeUrl);
	if(looping) this.audio.loop = looping;
	this.audio.play();
}

AppMobiContext.prototype.toggleBackgroundSound = function() {
	if(this.audio == null) return;
	if(this.audio.paused) {
		this.audio.play();
	} else {
		this.audio.pause();
	}
}
AppMobiContext.prototype.stopBackgroundSound = function() {
	if(this.audio == null) return;
	this.audio.pause();
}

AppMobiContext.prototype.setDurationForShortSoundsInSecs = function(seconds) {
	screenCanvas.audioSetDuratioinForShortSounds(seconds);
}

AppMobiContext.prototype.playSound = function(relativeUrl, looping) {
	if(!this.sounds[relativeUrl]) {
		this.sounds[relativeUrl] = new Audio(relativeUrl);
		this.sounds[relativeUrl].src = relativeUrl;
		if(typeof looping != "undefined") {
			this.sounds[relativeUrl].loop = looping;
		}
					
		this.sounds[relativeUrl].play();
	} else {
		if(this.sounds[relativeUrl].paused) {
			this.sounds[relativeUrl].play();
		}
	}
}

AppMobiContext.prototype.resumeSound = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		if(this.sounds[relativeUrl].paused) {
			this.sounds[relativeUrl].play();
		}
	}
}

AppMobiContext.prototype.paused = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		return this.sounds[relativeUrl].paused;
	}
}

AppMobiContext.prototype.pauseSound = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		this.sounds[relativeUrl].pause();
	}
}

AppMobiContext.prototype.stopSound = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		this.sounds[relativeUrl].stop();
	}
}

AppMobiContext.prototype.setLoopingSound = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		if (this.sounds[relativeUrl].loop !== !!l){
			this.sounds[relativeUrl].loop = !!l;
		}
	}
}

AppMobiContext.prototype.seekSound = function(relativeUrl, pos) {
	if(this.sounds[relativeUrl]) {
		if(this.sounds[relativeUrl].paused) {
			this.sounds[relativeUrl].currentTime = pos;
		}else {
			this.sounds[relativeUrl].pause();
			this.sounds[relativeUrl].currentTime = pos;
			this.sounds[relativeUrl].play();
		}
	}
}

AppMobiContext.prototype.getPlaybackTimeSound = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		return this.sounds[relativeUrl].currentTime;
	}
}

AppMobiContext.prototype.getDurationSound = function(relativeUrl) {
	if(this.sounds[relativeUrl]) {
		return this.sounds[relativeUrl].duration;
	}
}

AppMobiContext.prototype.loadSound = function(relativeUrl) {
	this.sounds[relativeUrl] = new Audio(relativeUrl);
}

AppMobiContext.prototype.loadPolySound = function(relativeUrl, count) {
	this.sounds[relativeUrl] = [];
	this.sounds[relativeUrl].isPoly = true;
	for(var i=0;i<count;i++) {
		this.sounds[relativeUrl][i] = new Audio(relativeUrl);
	}
}

AppMobiContext.prototype.unloadSound = function(relativeUrl) {
	this.sounds[relativeUrl] = null;
	delete this.sounds[relativeUrl];
}

AppMobiContext.prototype.unloadAllSounds = function() {
	this.sounds = [];
}

AppMobi.context = new AppMobiContext();

//screenCanvas.log('screenCanvas.log test');
console = function() {
	return {
		log: function(val) {
			screenCanvas.log(val);
		}
	}
}();
console.assert = function(cond, msg) {
	if(!cond)console.log(msg);
}
console.debug = console.log;
console.info = console.log;
console.error = console.log;
console.warn = console.log;
console.trace = function trace() {
	console.log('this should be a stack trace');
};
//console.log('console.log test');

//timers are managed from java TimerTasks
(function(){

	var timers = [];
  
	setTimeout = function(callback, ms) {
		var id = timers.length;
		
		if(typeof callback == "string") {
			var callback_string = callback;
			callback = function(){eval(callback_string)};
		}
		
		timers[id] = callback;

		//console.log('setTimeout('+ms+'), id:'+id+' callback:'+callback);
		
		//add TimerTask
		screenCanvas.addTimer(id, ms, false);
		
		return id;
	}

	clearTimeout = function(id) {
		screenCanvas.removeTimer(id);

		return delete timers[id];	
	}
	
	setInterval = function(callback, ms) {
		var id = timers.length;
		
		if(typeof callback == "string") {
			var callback_string = callback;
			callback = function(){eval(callback_string)};
		}
		
		timers[id] = callback;
		
		//console.log('setInterval('+ms+'), id:'+id+' callback:'+callback);
		
		//add TimerTask
		screenCanvas.addTimer(id, ms, true);
		
		return id;
	}

	clearInterval = function(id) {
		//console.log('clearInterval '+id);
		screenCanvas.removeTimer(id);

		return delete timers[id];	
	}

	invokeTimer = function(id) {
		try{
			var timer = timers[id];
			if(timer) {
				timers[id]();
			} else {
				console.log('missing timer:'+id);
			} 
			
		} catch(e) {
			console.log("trapped invokeTimer error, timers.length:"+timers.length+", requested id:"+id);
			console.log("e.message:"+e.message);
		}
	}
  
})()

//allow binding
Function.prototype.bind = function(bind) {
	var self = this;
	return function(){
		var args = Array.prototype.slice.call(arguments);
		return self.apply(bind || null, args);
	};
};

//setup minimal DOM support
window = this;
window.location = '';
window.location.search = '';

// Set up a fake HTMLElement and document object, so DirectCanvas is happy
HTMLElement = function( tagName ){ 
	this.tagName = tagName;
	this.children = [];
};

HTMLElement.prototype.appendChild = function( element ) {
	this.children.push( element );
	
	// If the child is a script element, begin loading it
	if( element.tagName == 'script' ) {
		if(element.src) {
			var to = 
			function(){
				//console.log('appendChild, element.src:'+element.src);
				AppMobi.context.include( element.src ); 
				if( typeof element.onload == "function" ) {
					element.onload();
				}
			};
			var id = setTimeout( to, 1 );
		} else {
			console.log('appendChild called for script without src');
		}
	}
};
document = {
	location: { href: 'index' },
	
	head: new HTMLElement( 'head' ),
	body: new HTMLElement( 'body' ),
	
	createElement: function( name, height, width ) {
		if( name == 'canvas' ) {
			if(typeof height == "undefined") {
				height = 300;
			}
			if(typeof weight == "undefined") {
				weight = 300;
			}
			var c = new CanvasConstructor(height, weight, false);
			var context = new DContext(c);
			return {
				getContext: function() {
					return context;
				},
				set height(h) {
					return context.directCanvas.setHeight(h);
				},
				get height() {
					return context.directCanvas.getHeight();
				},
				set width(w) {
					return context.directCanvas.setWidth(w);
				},
				get width() {
					return context.directCanvas.getWidth();
				}
			}
		} else if ( name == 'image') {
			return new Image();
        } else {
            return new HTMLElement( 'script' );
        }
	},
	
	getElementById: function( id ){	
		return null;
	},
	
	getElementsByTagName: function( tagName ){
		if( tagName == 'head' ) {
			return [document.head];
		}
	},
	
	addEventListener: function( type, callback ){
		if( type == 'DOMContentLoaded' ) {
			setTimeout( callback, 1 );
		}
	},
	createEvent: function(){
		return new Event();
	}
};
addEventListener = function( type, callback ){};
devicePixelRatio = 1;//AppMobi.context.devicePixelRatio;
/*
if( AppMobi.context.landscapeMode ) {
	innerWidth = AppMobi.context.screenWidth;
	innerHeight = AppMobi.context.screenHeight;
}
else {
	innerWidth = AppMobi.context.screenWidth;
	innerHeight = AppMobi.context.screenHeight;
}
*/
screen = {
	availWidth: 1024,//innerWidth,
	availHeight: 768//innerHeight
};

navigator = {
	userAgent: "hardcoded"//AppMobi.context.userAgent
};

Canvas = AppMobi.canvas;
//================================================================
// DIRECT CANVAS TOUCH TRANSLATION
//================================================================	
Canvas._orig_addEventListener = Canvas.addEventListener;
Canvas._orig_removeEventListener = Canvas.removeEventListener;

Canvas.addEventListener = function(eventType, eventHandler, eventCapture)
{
	if(eventType in {"touchstart":'',"touchmove":'',"touchend":''}) {
		//AppMobi.webview.execute("AppMobi.multitouch.add(document, '"+eventType+"', AppMobi.canvas.forwardTouchEvent, false);");
		AppMobi.webview.execute("document.addEventListener('"+eventType+"', AppMobi.canvas.forwardTouchEvent, false);");
	}
	this._orig_addEventListener(eventType, eventHandler, eventCapture);
}

Canvas.removeEventListener = function(eventType, eventHandler, eventCapture)
{
	if(eventType in {"touchstart":'',"touchmove":'',"touchend":''})
		//AppMobi.webview.execute("AppMobi.multitouch.remove(document, '"+eventType+"', AppMobi.canvas.forwardTouchEvent, false);");
		AppMobi.webview.execute("document.removeEventListener('"+eventType+"', AppMobi.canvas.forwardTouchEvent, false);");
	this._orig_removeEventListener(eventType, eventHandler, eventCapture);
}

Canvas.setMouseCoords = function(orientation, dwidth, dheight, webW, webH, touches, targetTouches, changedTouches, eventType)
{
	//AppMobi.context.log('in setMouseCoords');
	
	var cwidth, cheight, wscale, hscale, scaleFactor;
	
	cwidth = AppMobi.canvas.width;//AppMobi.canvas.context.width;
	cheight = AppMobi.canvas.height;//AppMobi.canvas.context.height;	


	wscale = cwidth/webW;
	hscale = cheight/webH;
	// console.log("touches:"+touches+" hscale: "+hscale+" wscale= "+wscale+" eventType: "+eventType);
	
	var fixCoords = function(touches) {
		var newTouches = [];
		for(var i=0;i<touches.length;i++) {
			
			touches[i][1] = parseInt(touches[i][1]*wscale);
			touches[i][2] = parseInt(touches[i][2]*hscale);

			var touch = {};
			touch.identifier=touches[i][0];
			touch.pageX=touches[i][1];
			touch.pageY=touches[i][2];
			touch.clientX=touches[i][1];
			touch.clientY=touches[i][2];
			touch.screenX=touches[i][1];
			touch.screenY=touches[i][2];
			
			if(eventType=='touchend' || (touch.pageX >= 0 && touch.pageX < cwidth && touch.pageY >= 0 && touch.pageY < cheight))
			{
				newTouches.push(touch);
			//} else {
			//	console.log('touch.pageX:'+touch.pageX+', touch.pageY:'+touch.pageY);
			}
		}
		return newTouches;
	}
	
	//console.log('in setMouseCoords:touches - '+touches);
	
	touches = fixCoords(eval(touches));
	targetTouches = fixCoords(eval(targetTouches));
	changedTouches = fixCoords(eval(changedTouches));

	AppMobi.canvas.simulateTouchEvent(touches, targetTouches, changedTouches, eventType);
}

Canvas.simulateTouchEvent = function(touches,targetTouches,changedTouches,touchType)
{
	//console.log("simulateTouchEvent");
	if(touches.length==0 && changedTouches.length==0 && targetTouches.length==0) {
		console.log('throwing away touch event with empty touches property');
	} else {
		var touchevt = new TouchEvent();
		touchevt.initEvent(touchType, true, true);
		touchevt.touches = touches;
		touchevt.changedTouches = changedTouches;
		touchevt.targetTouches = targetTouches;
		// console.log("touchtype = "+touchType);
		AppMobi.canvas.dispatchEvent(touchevt);
	}
}

TouchEvent = function() {
	this.bubbles = true;
	this.cancelBubble = false;
	this.cancelable = true;
	this.clipboardData = undefined;
	this.currentTarget = null;
	this.defaultPrevented = false;
	this.eventPhase = 0;
	this.returnValue = true;
	this.srcElement = "";//Canvas;
	this.target = "";//Canvas;
	this.timestamp = -1;
	this.type = "";
	return this;
}
TouchEvent.prototype = {};
TouchEvent.prototype.initEvent = function(type, bubbles, cancelable) {
	if(arguments.length>0 && typeof arguments[0]=="string")this.type = type;
	if(arguments.length>1 && typeof arguments[1]=="boolean")this.bubbles = bubbles;
	if(arguments.length>2 && typeof arguments[2]=="boolean")this.cancelable = cancelable;
}

function testTouch(e) {
	console.log(e.type+" x:"+e.touches[0].pageX+", y:"+e.touches[0].pageY);
}
//AppMobi.canvas.addEventListener('touchstart', testTouch, false);
//AppMobi.canvas.addEventListener('touchend', testTouch, false);
//AppMobi.canvas.addEventListener('touchmove', testTouch, false);	
//================================================================

/*********************
make intel.xdk namespace work
*********************/
if (typeof(intel) != 'object') {
    intel = {};
}
intel.xdk = AppMobi;